<?php

namespace backend\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\MasterKompetensiUnit;

/**
 * MasterKompetensiUnitSearch represents the model behind the search form of `backend\models\MasterKompetensiUnit`.
 */
class MasterKompetensiUnitSearch extends MasterKompetensiUnit
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['MASKOM_UUID', 'MASKOMU_UUID', 'MASKOMU_ELEMEN', 'MASKOMU_KRITERIA', 'CREATED', 'USERNAME'], 'safe'],
            [['MASKOMU_URUT'], 'integer'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     * @param string|null $formName Form name to be used into `->load()` method.
     *
     * @return ActiveDataProvider
     */
    public function search($params, $formName = null)
    {
        $query = MasterKompetensiUnit::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params, $formName);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'MASKOMU_URUT' => $this->MASKOMU_URUT,
            'CREATED' => $this->CREATED,
        ]);

        $query->andFilterWhere(['like', 'MASKOM_UUID', $this->MASKOM_UUID])
            ->andFilterWhere(['like', 'MASKOMU_UUID', $this->MASKOMU_UUID])
            ->andFilterWhere(['like', 'MASKOMU_ELEMEN', $this->MASKOMU_ELEMEN])
            ->andFilterWhere(['like', 'MASKOMU_KRITERIA', $this->MASKOMU_KRITERIA])
            ->andFilterWhere(['like', 'USERNAME', $this->USERNAME]);

        return $dataProvider;
    }
}
